# Events

Keystrokes, mouse buttons and pointer motions are associated to specific events, wrapped around an [`Event`](@ref) that adds information regarding the type of event, time, location and the window on which the event happened.

For example, keystrokes are represented by [`KeyEvent`](@ref) structures, which contain all the details regarding the physical key that was pressed or released, along with context information and an interpretation of the associated key symbol. These include the code of the physical key, the symbol it was translated to, the associated input character, the active modifiers and the modifiers which were consumed during the translation.

Events are meant to be generated by iteration of an [`EventQueue`](@ref).
